
/**********************************************************************
 * $Id: stack.c,v 1.3 92/11/30 11:40:11 drew Exp $
 **********************************************************************/

/**********************************************************************
 *   Copyright 1990,1991,1992,1993 by The University of Toronto,
 *		       Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute,  and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided  that the above copyright notice  appears in all copies and
 * that both the copyright notice and this permission notice  appear in
 * supporting documentation, and  that  the  name of The University  of
 * Toronto  not  be used  in advertising   or publicity pertaining   to
 * distribution  of   the software   without  specific, written   prior
 * permission.  The  University  of Toronto  makes   no representations
 * about the  suitability  of  this software  for  any purpose.   It is
 * provided "as is" without express or implied warranty.
 *
 * THE  UNIVERSITY OF  TORONTO DISCLAIMS ALL WARRANTIES  WITH REGARD TO
 * THIS SOFTWARE,  INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT  SHALL THE UNIVERSITY  OF TORONTO BE LIABLE
 * FOR ANY SPECIAL,  INDIRECT OR CONSEQUENTIAL  DAMAGES  OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF  USE, DATA OR PROFITS,  WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE  OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF OR  IN  CONNECTION   WITH  THE  USE OR  PERFORMANCE  OF THIS
 * SOFTWARE.
 **********************************************************************/

#include "itf.h"

void _TempStackPush(stack, thing)
struct STACK *stack;
generic *thing;
{
  struct STACK_MEMBER *member;
  if (stack->trash==NULL)
    member = ITempCalloc(struct STACK_MEMBER, 1);
  else {
    member = stack->trash;
    stack->trash = stack->trash->next;
  }
  member->item = thing;
  member->next = stack->top;
  stack->height++;
  stack->top = member;
}

generic *_TempStackPop(stack)
struct STACK *stack;
{
  struct STACK_MEMBER *member = stack->top;
  if (member==NULL)
    IErrorAbort("TempStackPop: nothing on stack");
  stack->top = member->next;
  member->next = stack->trash;
  stack->trash = member;
  stack->height--;
  return member->item;
}

struct STACK *TempStackNew()
{
  struct STACK *stack;
  stack = ITempCalloc(struct STACK, 1);
  stack->top = NULL;
  stack->trash = NULL;
  stack->height = 0;
  return stack;
}
